

// This C++ file was created by SanEditor

#include "Atomic/det/detSAN.h"

#include <stdlib.h>
#include <iostream.h>

#include <math.h>


/*****************************************************************
                         detSAN Constructor             
******************************************************************/


detSAN::detSAN(){


  Activity* InitialActionList[7]={
    &T1, //0
    &T2, //1
    &T3, //2
    &D1, //3
    &T4, //4
    &T5, //5
    &Treset  // 6
  };

  BaseGroupClass* InitialGroupList[7]={
    (BaseGroupClass*) &(T1), 
    (BaseGroupClass*) &(T2), 
    (BaseGroupClass*) &(T3), 
    (BaseGroupClass*) &(D1), 
    (BaseGroupClass*) &(T4), 
    (BaseGroupClass*) &(T5), 
    (BaseGroupClass*) &(Treset)
  };

  a = new Place("a" ,1);
  b = new Place("b" ,0);
  c = new Place("c" ,0);
  d = new Place("d" ,1);
  e = new Place("e" ,0);
  f = new Place("f" ,0);
  BaseStateVariableClass* InitialPlaces[6]={
    a,  // 0
    b,  // 1
    c,  // 2
    d,  // 3
    e,  // 4
    f   // 5
  };
  BaseStateVariableClass* InitialROPlaces[0]={
  };
  initializeSANModelNow("det", 6, InitialPlaces, 
                        0, InitialROPlaces, 
                        7, InitialActionList, 7, InitialGroupList);


  assignPlacesToActivitiesInst();
  assignPlacesToActivitiesTimed();

  int AffectArcs[16][2]={ 
    {0,0}, {1,0}, {1,1}, {2,1}, {2,2}, {0,2}, {3,3}, {4,3}, {4,4}, 
    {3,4}, {4,5}, {2,5}, {5,5}, {5,6}, {0,6}, {3,6}
  };
  for(int n=0;n<16;n++) {
    AddAffectArc(InitialPlaces[AffectArcs[n][0]],
                 InitialActionList[AffectArcs[n][1]]);
  }
  int EnableArcs[8][2]={ 
    {0,0}, {1,1}, {2,2}, {3,3}, {4,4}, {4,5}, {2,5}, {5,6}
  };
  for(int n=0;n<8;n++) {
    AddEnableArc(InitialPlaces[EnableArcs[n][0]],
                 InitialActionList[EnableArcs[n][1]]);
  }

  for(int n=0;n<7;n++) {
    InitialActionList[n]->LinkVariables();
  }
  CustomInitialization();

}

void detSAN::CustomInitialization() {

}
detSAN::~detSAN(){
  for (int i = 0; i < NumStateVariables-NumReadOnlyPlaces; i++)
    delete LocalStateVariables[i];
};

void detSAN::assignPlacesToActivitiesInst(){
}
void detSAN::assignPlacesToActivitiesTimed(){
  T1.a = (Place*) LocalStateVariables[0];
  T1.b = (Place*) LocalStateVariables[1];
  T2.b = (Place*) LocalStateVariables[1];
  T2.c = (Place*) LocalStateVariables[2];
  T3.c = (Place*) LocalStateVariables[2];
  T3.a = (Place*) LocalStateVariables[0];
  D1.d = (Place*) LocalStateVariables[3];
  D1.e = (Place*) LocalStateVariables[4];
  T4.e = (Place*) LocalStateVariables[4];
  T4.d = (Place*) LocalStateVariables[3];
  T5.e = (Place*) LocalStateVariables[4];
  T5.c = (Place*) LocalStateVariables[2];
  T5.f = (Place*) LocalStateVariables[5];
  Treset.f = (Place*) LocalStateVariables[5];
  Treset.a = (Place*) LocalStateVariables[0];
  Treset.d = (Place*) LocalStateVariables[3];
}
/*****************************************************************/
/*                  Activity Method Definitions                  */
/*****************************************************************/

/*======================T1Activity========================*/

detSAN::T1Activity::T1Activity(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("T1",0,Exponential, RaceEnabled, 2,1, false);
}

detSAN::T1Activity::~T1Activity(){
  delete[] TheDistributionParameters;
}

void detSAN::T1Activity::LinkVariables(){
  a->Register(&a_Mobius_Mark);
  b->Register(&b_Mobius_Mark);
}

bool detSAN::T1Activity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((*(a_Mobius_Mark)) >=1));
  return NewEnabled;
}

double detSAN::T1Activity::Rate(){
  return 10;
  return 1.0;  // default rate if none is specified
}

double detSAN::T1Activity::Weight(){ 
  return 1;
}

bool detSAN::T1Activity::ReactivationPredicate(){ 
  return false;
}

bool detSAN::T1Activity::ReactivationFunction(){ 
  return false;
}

double detSAN::T1Activity::SampleDistribution(){
  return TheDistribution->Exponential(10);
}

double* detSAN::T1Activity::ReturnDistributionParameters(){
  TheDistributionParameters[0] = Rate();
  return TheDistributionParameters;
}

int detSAN::T1Activity::Rank(){
  return 1;
}

BaseActionClass* detSAN::T1Activity::Fire(){
  (*(a_Mobius_Mark))--;
  (*(b_Mobius_Mark))++;
  return this;
}

/*======================T2Activity========================*/

detSAN::T2Activity::T2Activity(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("T2",1,Exponential, RaceEnabled, 2,1, false);
}

detSAN::T2Activity::~T2Activity(){
  delete[] TheDistributionParameters;
}

void detSAN::T2Activity::LinkVariables(){
  b->Register(&b_Mobius_Mark);
  c->Register(&c_Mobius_Mark);
}

bool detSAN::T2Activity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((*(b_Mobius_Mark)) >=1));
  return NewEnabled;
}

double detSAN::T2Activity::Rate(){
  return 2;
  return 1.0;  // default rate if none is specified
}

double detSAN::T2Activity::Weight(){ 
  return 1;
}

bool detSAN::T2Activity::ReactivationPredicate(){ 
  return false;
}

bool detSAN::T2Activity::ReactivationFunction(){ 
  return false;
}

double detSAN::T2Activity::SampleDistribution(){
  return TheDistribution->Exponential(2);
}

double* detSAN::T2Activity::ReturnDistributionParameters(){
  TheDistributionParameters[0] = Rate();
  return TheDistributionParameters;
}

int detSAN::T2Activity::Rank(){
  return 1;
}

BaseActionClass* detSAN::T2Activity::Fire(){
  (*(b_Mobius_Mark))--;
  (*(c_Mobius_Mark))++;
  return this;
}

/*======================T3Activity========================*/

detSAN::T3Activity::T3Activity(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("T3",2,Exponential, RaceEnabled, 2,1, false);
}

detSAN::T3Activity::~T3Activity(){
  delete[] TheDistributionParameters;
}

void detSAN::T3Activity::LinkVariables(){
  c->Register(&c_Mobius_Mark);
  a->Register(&a_Mobius_Mark);
}

bool detSAN::T3Activity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((*(c_Mobius_Mark)) >=1));
  return NewEnabled;
}

double detSAN::T3Activity::Rate(){
  return 5;
  return 1.0;  // default rate if none is specified
}

double detSAN::T3Activity::Weight(){ 
  return 1;
}

bool detSAN::T3Activity::ReactivationPredicate(){ 
  return false;
}

bool detSAN::T3Activity::ReactivationFunction(){ 
  return false;
}

double detSAN::T3Activity::SampleDistribution(){
  return TheDistribution->Exponential(5);
}

double* detSAN::T3Activity::ReturnDistributionParameters(){
  TheDistributionParameters[0] = Rate();
  return TheDistributionParameters;
}

int detSAN::T3Activity::Rank(){
  return 1;
}

BaseActionClass* detSAN::T3Activity::Fire(){
  (*(c_Mobius_Mark))--;
  (*(a_Mobius_Mark))++;
  return this;
}

/*======================D1Activity========================*/

detSAN::D1Activity::D1Activity(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("D1",3,Deterministic, RaceEnabled, 2,1, false);
}

detSAN::D1Activity::~D1Activity(){
  delete[] TheDistributionParameters;
}

void detSAN::D1Activity::LinkVariables(){
  d->Register(&d_Mobius_Mark);
  e->Register(&e_Mobius_Mark);
}

bool detSAN::D1Activity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((*(d_Mobius_Mark)) >=1));
  return NewEnabled;
}

double detSAN::D1Activity::DeterministicParamValue(){
  return 2;
  return 1.0;  // default rate if none is specified
}

double detSAN::D1Activity::Weight(){ 
  return 1;
}

bool detSAN::D1Activity::ReactivationPredicate(){ 
  return false;
}

bool detSAN::D1Activity::ReactivationFunction(){ 
  return false;
}

double detSAN::D1Activity::SampleDistribution(){
  return 2;
}

double* detSAN::D1Activity::ReturnDistributionParameters(){
  TheDistributionParameters[0] = DeterministicParamValue();
  return TheDistributionParameters;
}

int detSAN::D1Activity::Rank(){
  return 1;
}

BaseActionClass* detSAN::D1Activity::Fire(){
  (*(d_Mobius_Mark))--;
  (*(e_Mobius_Mark))++;
  return this;
}

/*======================T4Activity========================*/

detSAN::T4Activity::T4Activity(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("T4",4,Exponential, RaceEnabled, 2,1, false);
}

detSAN::T4Activity::~T4Activity(){
  delete[] TheDistributionParameters;
}

void detSAN::T4Activity::LinkVariables(){
  e->Register(&e_Mobius_Mark);
  d->Register(&d_Mobius_Mark);
}

bool detSAN::T4Activity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((*(e_Mobius_Mark)) >=1));
  return NewEnabled;
}

double detSAN::T4Activity::Rate(){
  return 0.76;
  return 1.0;  // default rate if none is specified
}

double detSAN::T4Activity::Weight(){ 
  return 1;
}

bool detSAN::T4Activity::ReactivationPredicate(){ 
  return false;
}

bool detSAN::T4Activity::ReactivationFunction(){ 
  return false;
}

double detSAN::T4Activity::SampleDistribution(){
  return TheDistribution->Exponential(0.76);
}

double* detSAN::T4Activity::ReturnDistributionParameters(){
  TheDistributionParameters[0] = Rate();
  return TheDistributionParameters;
}

int detSAN::T4Activity::Rank(){
  return 1;
}

BaseActionClass* detSAN::T4Activity::Fire(){
  (*(e_Mobius_Mark))--;
  (*(d_Mobius_Mark))++;
  return this;
}

/*======================T5Activity========================*/

detSAN::T5Activity::T5Activity(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("T5",5,Exponential, RaceEnabled, 3,2, false);
}

detSAN::T5Activity::~T5Activity(){
  delete[] TheDistributionParameters;
}

void detSAN::T5Activity::LinkVariables(){
  e->Register(&e_Mobius_Mark);
  c->Register(&c_Mobius_Mark);
  f->Register(&f_Mobius_Mark);
}

bool detSAN::T5Activity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((*(e_Mobius_Mark)) >=1)&&((*(c_Mobius_Mark)) >=1));
  return NewEnabled;
}

double detSAN::T5Activity::Rate(){
  return 0.2;
  return 1.0;  // default rate if none is specified
}

double detSAN::T5Activity::Weight(){ 
  return 1;
}

bool detSAN::T5Activity::ReactivationPredicate(){ 
  return false;
}

bool detSAN::T5Activity::ReactivationFunction(){ 
  return false;
}

double detSAN::T5Activity::SampleDistribution(){
  return TheDistribution->Exponential(0.2);
}

double* detSAN::T5Activity::ReturnDistributionParameters(){
  TheDistributionParameters[0] = Rate();
  return TheDistributionParameters;
}

int detSAN::T5Activity::Rank(){
  return 1;
}

BaseActionClass* detSAN::T5Activity::Fire(){
  (*(e_Mobius_Mark))--;
  (*(c_Mobius_Mark))--;
  (*(f_Mobius_Mark))++;
  return this;
}

/*======================TresetActivity========================*/

detSAN::TresetActivity::TresetActivity(){
  TheDistributionParameters = new double[1];
  ActivityInitialize("Treset",6,Exponential, RaceEnabled, 3,1, false);
}

detSAN::TresetActivity::~TresetActivity(){
  delete[] TheDistributionParameters;
}

void detSAN::TresetActivity::LinkVariables(){
  f->Register(&f_Mobius_Mark);
  a->Register(&a_Mobius_Mark);
  d->Register(&d_Mobius_Mark);
}

bool detSAN::TresetActivity::Enabled(){
  OldEnabled=NewEnabled;
  NewEnabled=(((*(f_Mobius_Mark)) >=1));
  return NewEnabled;
}

double detSAN::TresetActivity::Rate(){
  return 1;
  return 1.0;  // default rate if none is specified
}

double detSAN::TresetActivity::Weight(){ 
  return 1;
}

bool detSAN::TresetActivity::ReactivationPredicate(){ 
  return false;
}

bool detSAN::TresetActivity::ReactivationFunction(){ 
  return false;
}

double detSAN::TresetActivity::SampleDistribution(){
  return TheDistribution->Exponential(1);
}

double* detSAN::TresetActivity::ReturnDistributionParameters(){
  TheDistributionParameters[0] = Rate();
  return TheDistributionParameters;
}

int detSAN::TresetActivity::Rank(){
  return 1;
}

BaseActionClass* detSAN::TresetActivity::Fire(){
  (*(f_Mobius_Mark))--;
  a->Mark()=1;
d->Mark()=1;
  return this;
}

