#ifndef detSAN_H_
#define detSAN_H_

#include "Cpp/BaseClasses/EmptyGroup.h"
#include "Cpp/BaseClasses/PreselectGroup.h"
#include "Cpp/BaseClasses/PostselectGroup.h"
#include "Cpp/BaseClasses/state/StructStateVariable.h"
#include "Cpp/BaseClasses/state/ArrayStateVariable.h"
#include "Cpp/BaseClasses/SAN/SANModel.h" 
#include "Cpp/BaseClasses/SAN/Place.h"
#include "Cpp/BaseClasses/SAN/ExtendedPlace.h"
extern UserDistributions* TheDistribution;

void MemoryError();


/*********************************************************************
               detSAN Submodel Definition                   
*********************************************************************/

class detSAN:public SANModel{
public:

class T1Activity:public Activity {
public:

  Place* a;
  short* a_Mobius_Mark;
  Place* b;
  short* b_Mobius_Mark;

  double* TheDistributionParameters;
  T1Activity();
  ~T1Activity();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
  double Rate();
}; // T1ActivityActivity

class T2Activity:public Activity {
public:

  Place* b;
  short* b_Mobius_Mark;
  Place* c;
  short* c_Mobius_Mark;

  double* TheDistributionParameters;
  T2Activity();
  ~T2Activity();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
  double Rate();
}; // T2ActivityActivity

class T3Activity:public Activity {
public:

  Place* c;
  short* c_Mobius_Mark;
  Place* a;
  short* a_Mobius_Mark;

  double* TheDistributionParameters;
  T3Activity();
  ~T3Activity();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
  double Rate();
}; // T3ActivityActivity

class D1Activity:public Activity {
public:

  Place* d;
  short* d_Mobius_Mark;
  Place* e;
  short* e_Mobius_Mark;

  double* TheDistributionParameters;
  D1Activity();
  ~D1Activity();
  double Rate(){return 0;}
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
  double DeterministicParamValue();
}; // D1ActivityActivity

class T4Activity:public Activity {
public:

  Place* e;
  short* e_Mobius_Mark;
  Place* d;
  short* d_Mobius_Mark;

  double* TheDistributionParameters;
  T4Activity();
  ~T4Activity();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
  double Rate();
}; // T4ActivityActivity

class T5Activity:public Activity {
public:

  Place* e;
  short* e_Mobius_Mark;
  Place* c;
  short* c_Mobius_Mark;
  Place* f;
  short* f_Mobius_Mark;

  double* TheDistributionParameters;
  T5Activity();
  ~T5Activity();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
  double Rate();
}; // T5ActivityActivity

class TresetActivity:public Activity {
public:

  Place* f;
  short* f_Mobius_Mark;
  Place* a;
  short* a_Mobius_Mark;
  Place* d;
  short* d_Mobius_Mark;

  double* TheDistributionParameters;
  TresetActivity();
  ~TresetActivity();
  bool Enabled();
  void LinkVariables();
  double Weight();
  bool ReactivationPredicate();
  bool ReactivationFunction();
  double SampleDistribution();
  double* ReturnDistributionParameters();
  int Rank();
  BaseActionClass* Fire();
  double Rate();
}; // TresetActivityActivity

  //List of user-specified place names
  Place* a;
  Place* b;
  Place* c;
  Place* d;
  Place* e;
  Place* f;

  // Create instances of all actvities
  T1Activity T1;
  T2Activity T2;
  T3Activity T3;
  D1Activity D1;
  T4Activity T4;
  T5Activity T5;
  TresetActivity Treset;
  //Create instances of all groups 
  EmptyGroup ImmediateGroup;

  detSAN();
  ~detSAN();
  void CustomInitialization();

  void assignPlacesToActivitiesInst();
  void assignPlacesToActivitiesTimed();
}; // end detSAN

#endif // detSAN_H_
