#include "PVMPVNodes.h"

PVMPV0Worker::PVMPV0Worker()
{
  NumModels = 1;
  TheModelPtr = new BaseModelClass**[NumModels];
  TheModelPtr[0] = (BaseModelClass**)(&det);
}

PVMPV0Worker::~PVMPV0Worker() {
  delete [] TheModelPtr;
}

double PVMPV0Worker::Reward_Function(void) {

return det->d->Mark();

return (0);



}

PVMPV0::PVMPV0(int timeindex) {
  TheModelPtr = (BaseModelClass**)(&ThedetSAN);
  double startpts[1]={10.0};
  double stoppts[1]={10.0+100.0};
  Initialize("pD",(RewardType)3,1, startpts, stoppts, timeindex, 0,1, 1);
  Type = steady_state;
  AddVariableDependency("d","det");
}

PVMPV0::~PVMPV0() {
  for(int i = 0; i < NumberOfWorkers; i++) {
    delete[] WorkerList[i]->Name;
    delete WorkerList[i];
  }
}

void PVMPV0::CreateWorkerList(void) {
  for(int i = 0; i < NumberOfWorkers; i++)
    WorkerList[i] = new PVMPV0Worker;
}
PVMPV1Worker::PVMPV1Worker()
{
  NumModels = 1;
  TheModelPtr = new BaseModelClass**[NumModels];
  TheModelPtr[0] = (BaseModelClass**)(&det);
}

PVMPV1Worker::~PVMPV1Worker() {
  delete [] TheModelPtr;
}

double PVMPV1Worker::Reward_Function(void) {

return det->e->Mark();

return (0);



}

PVMPV1::PVMPV1(int timeindex) {
  TheModelPtr = (BaseModelClass**)(&ThedetSAN);
  double startpts[1]={10.0};
  double stoppts[1]={10.0+100.0};
  Initialize("pE",(RewardType)3,1, startpts, stoppts, timeindex, 0,1, 1);
  Type = steady_state;
  AddVariableDependency("e","det");
}

PVMPV1::~PVMPV1() {
  for(int i = 0; i < NumberOfWorkers; i++) {
    delete[] WorkerList[i]->Name;
    delete WorkerList[i];
  }
}

void PVMPV1::CreateWorkerList(void) {
  for(int i = 0; i < NumberOfWorkers; i++)
    WorkerList[i] = new PVMPV1Worker;
}
